package kmeans_frag.paramsOUT;

import integratedtoolkit.types.annotations.Method;
import integratedtoolkit.types.annotations.Parameter;
import integratedtoolkit.types.annotations.Parameter.Direction;
import integratedtoolkit.types.annotations.Parameter.Type;


public interface KMeans_fragItf {
	
	@Method(declaringClass = "kmeans_frag.paramsOUT.KMeans_frag")
    Fragment readDatasetFromFile(
    		@Parameter(type = Type.STRING) String path,
    		@Parameter int numV, 
    		@Parameter int nDimensions
    );
    
	@Method(declaringClass = "kmeans_frag.paramsOUT.KMeans_frag")
	void clusters_points_partial(
			@Parameter Fragment points,
			@Parameter Fragment mu,
			@Parameter int k,
			@Parameter int ind,
			@Parameter(direction = Direction.OUT) Clusters clustersOfFrag
	);

	@Method(declaringClass = "kmeans_frag.paramsOUT.KMeans_frag")
	void partial_sum(
			@Parameter Fragment points,
			@Parameter Clusters cluster,
			@Parameter int k,
			@Parameter int ind,
			@Parameter(direction = Direction.OUT) SumPoints pSum
	);

	@Method(declaringClass = "kmeans_frag.paramsOUT.KMeans_frag", priority = true)
	void reduceCentersTask(
			@Parameter SumPoints a,
			@Parameter SumPoints b,
			@Parameter(direction = Direction.OUT) SumPoints c
	);

}
