package kmeans_frag.sequentialMerge;

import integratedtoolkit.types.annotations.Method;
import integratedtoolkit.types.annotations.Parameter;
import integratedtoolkit.types.annotations.Parameter.Type;


public interface KMeans_fragItf {
	
	@Method(declaringClass = "kmeans_frag.sequentialMerge.KMeans_frag")
    Fragment readDatasetFromFile(
    		@Parameter(type = Type.STRING) String path,
    		@Parameter int numV, 
    		@Parameter int nDimensions
    );
    
	@Method(declaringClass = "kmeans_frag.sequentialMerge.KMeans_frag")
	Clusters clusters_points_partial(
			@Parameter Fragment points,
			@Parameter Fragment mu,
			@Parameter int k,
			@Parameter int ind
	);

	@Method(declaringClass = "kmeans_frag.sequentialMerge.KMeans_frag")
	SumPoints partial_sum(
			@Parameter Fragment points,
			@Parameter Clusters cluster,
			@Parameter int k,
			@Parameter int ind
	);

	/*@Method(declaringClass = "kmeans_frag.sequentialMerge.KMeans_frag", priority = true)
	SumPoints reduceCentersTask(
			@Parameter SumPoints a,
			@Parameter SumPoints b
	);*/

}
